Debian Bug report logs - #701956
btrfs can't fsck /run/rootdev on boot with sysvinit

version graph

Package: initscripts; Maintainer for initscripts is Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>; Source for initscripts is src:sysvinit.

Reported by: Axel Beckert <abe@debian.org>

Date: Thu, 28 Feb 2013 23:18:02 UTC

Severity: critical

Tags: jessie, sid

Fixed in version sysvinit/2.88dsf-42

Done: Roger Leigh <rleigh@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, 701776@bugs.debian.org, Klaus@Ethgen.de, yann.soubeyrand@gmx.fr, ratcheer@gmail.com, christian.stalp@gmx.de, bzed@debian.org, Daniel Baumann <daniel.baumann@progress-technologies.net>:
Bug#701936; Package btrfs-tools. (Thu, 28 Feb 2013 23:18:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Axel Beckert <abe@debian.org>:
New Bug report received and forwarded. Copy sent to 701776@bugs.debian.org, Klaus@Ethgen.de, yann.soubeyrand@gmx.fr, ratcheer@gmail.com, christian.stalp@gmx.de, bzed@debian.org, Daniel Baumann <daniel.baumann@progress-technologies.net>. (Thu, 28 Feb 2013 23:18:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Axel Beckert <abe@debian.org>
To: submit@bugs.debian.org
Subject: btrfs-tools: renders systems with btrfs root file systems unbootable: "check_mounted(): Could not open /run/rootdev" + "Could not check mount status: No such device or address"
Date: Fri, 1 Mar 2013 00:14:39 +0100
Package: btrfs-tools
Version: 0.19+20130131-2
Severity: critical
Justification: renders systems with btrfs as root file-system unbootable

Hi,

Axel Beckert wrote on Wed, 27 Feb 2013 20:01:30 +0100:
> >  btrfs-tools (0.19+20130131-2) unstable; urgency=low
> >  .
> >    * Replacing fsck.btrfs with wrapper arround 'btrfs check' to avoid
> >      different behaviour based on the filename btrfs is copied to (Closes:
> >      #701776).
> 
> Thanks for the quick fix, but unfortunately the problem persists, just
> with a different error message and a different exit-code, but with the
> same symptom: The system fails to start.
> 
> check_mounted(): Could not open /run/rootdev
> Could not check mount status: No such device or address
> fsck died with exit status 250

There's one more confirmation that there's still an issue which breaks
systems, even with the newest version, at
http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=701776#65

Additionally, several people contacted me on Jabber/IRC about how to
fix this issue, too, so I'm posting a recipe at the end of this mail
and also Cc this mail to #701776.

> Do you have any preference if #701776 should be reopend or if a new
> bug should be filed for that?

Since I didn't get a reply from Daniel on this question within a day,
I'm herewith filing a new bug report as the issue may have a different
cause despite very similar symptoms and the affected systems still
being broken if you don't downgrade btrfs-tools to 0.19+20121004-1 or
earlier.

As I already wrote in #701776, I consider such breakage of severity
critical since http://www.debian.org/Bugs/Developer.en.html#severities
defines "critical" as "makes unrelated software on the system (or the
whole system) break". I see this condition as given.


For all those who are also suffering from this issue, too, here's the
recipe how I downgraded btrfs-tools to the version from testing again
on my system:

At the maintenance mode password prompt, enter the root password.

You may need to add /sbin and /usr/sbin to the path depending on your
login shell setup. Thanks Christian Stalp!
# export PATH="/sbin:/usr/sbin:$PATH"

With the default setup, sourcing /etc/profile should suffice.
# . /etc/profile

Mount the root file system read-write:
# mount -o remount,rw /

Mount the /boot partition, if existing:
# mount /boot

Either get network, ...
# dhclient eth0

(Since Julien Cristau NMUed btrfs-tools in Wheezy yesterday[1], you
may want to update your package lists, too.)
# apt-get update

..., fetch the version from testing (assuming you have a deb-line with
testing in your sources.list, too) and downgrade to it, ...
# apt-get install -t testing btrfs-tools

... or, if you haven't done "apt-get clean" for a while, you may be able to
just do
# dpkg -i /var/cache/apt/archives/btrfs-tools_0.19+20121004-1_*.deb

Then call sync to make sure the new version is on disk:

# sync

and reboot, e.g. by pressing Ctrl-D.

That way, both, Christian and me got working systems back again.


[1] http://packages.qa.debian.org/b/btrfs-tools/news/20130228T204729Z.html

		Regards, Axel
-- 
 ,''`.  |  Axel Beckert <abe@debian.org>, http://people.debian.org/~abe/
: :' :  |  Debian Developer, ftp.ch.debian.org Admin
`. `'   |  1024D: F067 EA27 26B9 C3FC 1486  202E C09E 1D89 9593 0EDE
  `-    |  4096R: 2517 B724 C5F6 CA99 5329  6E61 2FF9 CD59 6126 16B5



Information forwarded to debian-bugs-dist@lists.debian.org, Daniel Baumann <daniel.baumann@progress-technologies.net>:
Bug#701936; Package btrfs-tools. (Fri, 01 Mar 2013 02:18:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Axel Beckert <abe@debian.org>:
Extra info received and forwarded to list. Copy sent to Daniel Baumann <daniel.baumann@progress-technologies.net>. (Fri, 01 Mar 2013 02:18:05 GMT) Full text and rfc822 format available.

Message #10 received at 701936@bugs.debian.org (full text, mbox):

From: Axel Beckert <abe@debian.org>
To: 701936@bugs.debian.org
Subject: Re: Bug#701936: btrfs-tools: renders systems with btrfs root file systems unbootable: "check_mounted(): Could not open /run/rootdev" + "Could not check mount status: No such device or address"
Date: Fri, 1 Mar 2013 03:15:15 +0100
Hi,

some more information about the issue:

Happens on Sid i386 for me. /boot is a separate partition and / is a
btrfs upon a dm_crypt partition.

Axel Beckert wrote:
> > check_mounted(): Could not open /run/rootdev
> > Could not check mount status: No such device or address
> > fsck died with exit status 250

I provoked this situation again and also tried Dmitrijs's patch from
http://bugs.debian.org/cgi-bin/bugreport.cgi?msg=45;filename=fix-up-fsck.patch;att=1;bug=701776
in combination with Daniel's new wrapper, but that doesn't change
anything.

/run/rootdev exists in that situation and looks like this:

brw------- 1 root root 0, 16 Mar  1 00:56 /run/rootdev

It's not mounted at that point. (The root partition is mounted "ro" at
/dev/mapper/sda2_crypt in my case.)

From utils.c:

    812         fd = open(file, O_RDONLY);
    813         if (fd < 0) {
    814                 fprintf (stderr, "check_mounted(): Could not open %s\n", file);
    815                 return -errno;
    816         }

From open(3):

    ENXIO  The named file is a character special or block special file,
    	   and the device associated with this special file does not exist.

So "btrfs check" tries to read /run/rootdev but can't find the
according device to that block special file.

Potential explanations for this behaviour:

* /run/rootdev has the wrong major and minor numbers. (But it
  worked before, e.g. with btrfs-tools from testing. Nevertheless
  other tools like "less -f" provoke the same error.)

* "btrfs check" accesses the blockdevice in a different way than
  btrfsck did. (But I couldn't find any relevant difference in the
  source code compared to the code of the working version on a first a
  glance.)

So both explanations seem unrealistic for some reasons... Which
suggests that the culprit is probably somewhere else. :-/

		Regards, Axel
-- 
 ,''`.  |  Axel Beckert <abe@debian.org>, http://people.debian.org/~abe/
: :' :  |  Debian Developer, ftp.ch.debian.org Admin
`. `'   |  1024D: F067 EA27 26B9 C3FC 1486  202E C09E 1D89 9593 0EDE
  `-    |  4096R: 2517 B724 C5F6 CA99 5329  6E61 2FF9 CD59 6126 16B5



Changed Bug title to 'btrfs can't fsck /run/rootdev on boot' from 'btrfs-tools: renders systems with btrfs root file systems unbootable: "check_mounted(): Could not open /run/rootdev" + "Could not check mount status: No such device or address"' Request was from Daniel Baumann <daniel.baumann@progress-technologies.net> to control@bugs.debian.org. (Fri, 01 Mar 2013 06:33:03 GMT) Full text and rfc822 format available.

Severity set to 'serious' from 'critical' Request was from Daniel Baumann <daniel.baumann@progress-technologies.net> to control@bugs.debian.org. (Fri, 01 Mar 2013 06:33:04 GMT) Full text and rfc822 format available.

Added tag(s) sid. Request was from Daniel Baumann <daniel.baumann@progress-technologies.net> to control@bugs.debian.org. (Fri, 01 Mar 2013 06:33:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Daniel Baumann <daniel.baumann@progress-technologies.net>:
Bug#701936; Package btrfs-tools. (Fri, 01 Mar 2013 06:54:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to daniel.baumann@progress-technologies.net:
Extra info received and forwarded to list. Copy sent to Daniel Baumann <daniel.baumann@progress-technologies.net>. (Fri, 01 Mar 2013 06:54:03 GMT) Full text and rfc822 format available.

Message #21 received at 701936@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel.baumann@progress-technologies.net>
To: 701936@bugs.debian.org
Subject: Re: btrfs can't fsck /run/rootdev on boot
Date: Fri, 01 Mar 2013 07:50:37 +0100
retitle 701936 btrfs can't fsck /run/rootdev on boot with sysvinit
severity 701936 important
clone 701936 -1
reassign -1 sysvinit
thanks

works with systemd, it's sysvinit specific.

-- 
Address:        Daniel Baumann, Donnerbuehlweg 3, CH-3012 Bern
Email:          daniel.baumann@progress-technologies.net
Internet:       http://people.progress-technologies.net/~daniel.baumann/



Changed Bug title to 'btrfs can't fsck /run/rootdev on boot with sysvinit' from 'btrfs can't fsck /run/rootdev on boot' Request was from Daniel Baumann <daniel.baumann@progress-technologies.net> to control@bugs.debian.org. (Fri, 01 Mar 2013 06:54:05 GMT) Full text and rfc822 format available.

Severity set to 'important' from 'serious' Request was from Daniel Baumann <daniel.baumann@progress-technologies.net> to control@bugs.debian.org. (Fri, 01 Mar 2013 06:54:05 GMT) Full text and rfc822 format available.

Bug 701936 cloned as bug 701956 Request was from Daniel Baumann <daniel.baumann@progress-technologies.net> to control@bugs.debian.org. (Fri, 01 Mar 2013 06:54:06 GMT) Full text and rfc822 format available.

Bug reassigned from package 'btrfs-tools' to 'sysvinit'. Request was from Daniel Baumann <daniel.baumann@progress-technologies.net> to control@bugs.debian.org. (Fri, 01 Mar 2013 06:54:06 GMT) Full text and rfc822 format available.

No longer marked as found in versions btrfs-tools/0.19+20130131-2. Request was from Daniel Baumann <daniel.baumann@progress-technologies.net> to control@bugs.debian.org. (Fri, 01 Mar 2013 06:54:07 GMT) Full text and rfc822 format available.

Added indication that 701956 affects btrfs-tools Request was from Axel Beckert <abe@debian.org> to control@bugs.debian.org. (Wed, 06 Mar 2013 20:42:07 GMT) Full text and rfc822 format available.

Bug reassigned from package 'sysvinit' to 'initscripts'. Request was from Roger Leigh <rleigh@codelibre.net> to control@bugs.debian.org. (Wed, 06 Mar 2013 21:09:04 GMT) Full text and rfc822 format available.

Severity set to 'critical' from 'important' Request was from Roger Leigh <rleigh@codelibre.net> to control@bugs.debian.org. (Wed, 06 Mar 2013 21:09:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#701956; Package initscripts. (Sun, 17 Mar 2013 13:09:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Nis Martensen <nis.martensen@web.de>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Sun, 17 Mar 2013 13:09:06 GMT) Full text and rfc822 format available.

Message #42 received at 701956@bugs.debian.org (full text, mbox):

From: Nis Martensen <nis.martensen@web.de>
To: 701936@bugs.debian.org
Cc: Daniel Baumann <daniel.baumann@progress-technologies.net>
Subject: Re: btrfs can't fsck /run/rootdev on boot
Date: Sun, 17 Mar 2013 13:56:22 +0100
[Message part 1 (text/plain, inline)]
On Fri, Mar 01, 2013 at 07:50:37AM +0100, Daniel Baumann wrote:
> works with systemd, it's sysvinit specific.

Systemd skips the root file system check if the major device number of
the root file system is 0 (which is what btrfs reports):
http://cgit.freedesktop.org/systemd/systemd/tree/src/fsck/fsck.c#n297

The same could be done in sysvinit. Possible (untested) patch attached.
[0001-Skip-root-filesystem-check-for-btrfs-file-systems.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#701956; Package initscripts. (Tue, 19 Mar 2013 22:57:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@codelibre.net>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Tue, 19 Mar 2013 22:57:07 GMT) Full text and rfc822 format available.

Message #47 received at 701956@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@codelibre.net>
To: Nis Martensen <nis.martensen@web.de>, 701956@bugs.debian.org
Cc: 701936@bugs.debian.org, Daniel Baumann <daniel.baumann@progress-technologies.net>
Subject: Re: Bug#701956: btrfs can't fsck /run/rootdev on boot
Date: Tue, 19 Mar 2013 22:55:32 +0000
On Sun, Mar 17, 2013 at 01:56:22PM +0100, Nis Martensen wrote:
> On Fri, Mar 01, 2013 at 07:50:37AM +0100, Daniel Baumann wrote:
> > works with systemd, it's sysvinit specific.
> 
> Systemd skips the root file system check if the major device number of
> the root file system is 0 (which is what btrfs reports):
> http://cgit.freedesktop.org/systemd/systemd/tree/src/fsck/fsck.c#n297
> 
> The same could be done in sysvinit. Possible (untested) patch attached.

Thanks for the patch.  This will have to be deferred until after
wheezy is released, but if we have to work around the btrfs fsck
issues in this way, it looks like a reasonable approach.  I would
hope however that this would not be necessary, and that the btrfs
fsck will become compatible with the standard /sbin/fsck options
and behaviour, including being able to fsck a read-only mount, or
else some users of btrfs won't be able to check their filesystems.

Daniel, if you haven't done do already, it would be great if these
issues could be brought to the attention of the upstream developers.
As it stands, fsck.btrfs is not a compatible fsck, and this will
break any tool expecting it to work like /sbin/fsck, not just
sysvinit.


Regards,
Roger

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux    http://people.debian.org/~rleigh/
 `. `'   schroot and sbuild  http://alioth.debian.org/projects/buildd-tools
   `-    GPG Public Key      F33D 281D 470A B443 6756 147C 07B3 C8BC 4083 E800



Severity set to 'important' from 'critical' Request was from Roger Leigh <rleigh@codelibre.net> to control@bugs.debian.org. (Wed, 20 Mar 2013 21:21:07 GMT) Full text and rfc822 format available.

Added tag(s) jessie. Request was from Julien Cristau <jcristau@debian.org> to control@bugs.debian.org. (Thu, 18 Apr 2013 17:45:17 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#701956; Package initscripts. (Wed, 03 Jul 2013 13:30:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ben Klein <shacklein@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Wed, 03 Jul 2013 13:30:04 GMT) Full text and rfc822 format available.

Message #56 received at 701956@bugs.debian.org (full text, mbox):

From: Ben Klein <shacklein@gmail.com>
To: 701956@bugs.debian.org
Subject: Re: Bug#701956: btrfs can't fsck /run/rootdev on boot
Date: Wed, 3 Jul 2013 23:27:07 +1000
Bug still occurs with
* btrfs-tools 0.19+20130315-2
* sysv-rc 2.88dsf-41
* sysvinit 2.88dsf-41
* sysvinit-utils 2.88dsf-41
* initscripts 2.88dsf-41

I notice this bug has been reduced in severity from "critical" to
"important" again. Sorry, but I have to agree that it IS a critical
bug, unless systemd has suddenly become the standard init system.

Even worse, systemd is behaving incorrectly in this case, as it is
SKIPPING fsck instead of finding the root device some other way and
running fsck on that (though this would still trigger bug #712078). So
ultimately, the issue is either:
* in mountpoint's syscall for getting the device node, or
* in checkroot.sh which needs some btrfs-specific method to find the
correct argument to pass to btrfsck/btrfs check (taking subvolumes
into account)

I've attached an alternative patch for checkroot.sh that explicitly
checks for btrfs and, more importantly, triggers a warning when it is
detected.

On 3 July 2013 23:14, Mail Delivery Subsystem
<mailer-daemon@googlemail.com> wrote:
> Delivery to the following recipient failed permanently:
>
>      701936@bugs.debian.org
>
> Technical details of permanent failure:
> Google tried to deliver your message, but it was rejected by the server for the recipient domain bugs.debian.org by buxtehude.debian.org. [140.211.166.26].
>
> The error that the other server returned was:
> 550 Unknown or archived bug
>
> ----- Original message -----
>
> DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
>         d=gmail.com; s=20120113;
>         h=mime-version:from:date:message-id:subject:to:content-type;
>         bh=px+OPpHGSuCWET/ZpEdvUogwdz8Bfdx76muBojFroOQ=;
>         b=m5JA2Cuz+AKixuGZFAICuH7T6qpL6Tfo6Vz9PrqdDjkQlcNdJUxWvaV5ZZNFhWQzNH
>          UgZcCs91sIm12KDvVDgqCbrc2/iiSAscOvF1mPtXlDcxsZJTKOinDZwl4MacnQcrjj3t
>          v4kWDd/a5A0xI6nikrsjuefnpX+Xr3DIc4tuwZB295rXbggx/yNo18hxHQ4e5a518Rsn
>          2Iv2wDxT2hA8E7dTUFSrFsLSJRi3HwqUy/H9WlNbbrkbcfEVoz5/s4rlpVh4fJtBxfFa
>          TKzKvx1jEVP8HCWr89SsxuqP69JVFQaQHQHloJQ7qTN6ov6Z5SfhMDX8hFmH+NxrGYp9
>          SE3g==
> X-Received: by 10.194.249.129 with SMTP id yu1mr627241wjc.10.1372857234000;
>  Wed, 03 Jul 2013 06:13:54 -0700 (PDT)
> MIME-Version: 1.0
> Received: by 10.216.231.72 with HTTP; Wed, 3 Jul 2013 06:13:33 -0700 (PDT)
> From: Ben Klein <shacklein@gmail.com>
> Date: Wed, 3 Jul 2013 23:13:33 +1000
> Message-ID: <CAJboL970ELfVEgaVu5a+WUjRx-NA7YSVb1MtGdL1w3Ra56RaZw@mail.gmail.com>
> Subject: Re: Bug#701956: btrfs can't fsck /run/rootdev on boot
> To: 701936 <701936@bugs.debian.org>
> Content-Type: multipart/mixed; boundary=001a11c29996c2956804e09b3b40
>
> Bug still occurs with
> * btrfs-tools 0.19+20130315-2
> * sysv-rc 2.88dsf-41
> * sysvinit 2.88dsf-41
> * sysvinit-utils 2.88dsf-41
> * initscripts 2.88dsf-41
>
> I notice this bug has been reduced in severity from "critical" to
> "important" again. Sorry, but I have to agree that it IS a critical
> bug, unless systemd has suddenly become the standard init system.
>
> Even worse, systemd is behaving incorrectly in this case, as it is
> SKIPPING fsck instead of finding the root device some other way and
> running fsck on that (though this would still trigger bug #712078). So
> ultimately, the issue is either:
> * in mountpoint's syscall for getting the device node, or
> * in checkroot.sh which needs some btrfs-specific method to find the
> correct argument to pass to btrfsck/btrfs check (taking subvolumes
> into account)
>
> I've attached an alternative patch for checkroot.sh that explicitly
> checks for btrfs and, more importantly, triggers a warning when it is
> detected.



Severity set to 'critical' from 'important' Request was from Roger Leigh <rleigh@codelibre.net> to control@bugs.debian.org. (Sat, 13 Jul 2013 15:39:21 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#701956; Package initscripts. (Sat, 13 Jul 2013 15:57:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Roger Leigh <rleigh@codelibre.net>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Sat, 13 Jul 2013 15:57:09 GMT) Full text and rfc822 format available.

Message #63 received at 701956@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@codelibre.net>
To: Ben Klein <shacklein@gmail.com>, 701956@bugs.debian.org
Subject: Re: Bug#701956: btrfs can't fsck /run/rootdev on boot
Date: Sat, 13 Jul 2013 16:53:48 +0100
On Wed, Jul 03, 2013 at 11:27:07PM +1000, Ben Klein wrote:
> Bug still occurs with
> * btrfs-tools 0.19+20130315-2
> * sysv-rc 2.88dsf-41
> * sysvinit 2.88dsf-41
> * sysvinit-utils 2.88dsf-41
> * initscripts 2.88dsf-41
> 
> I notice this bug has been reduced in severity from "critical" to
> "important" again. Sorry, but I have to agree that it IS a critical
> bug, unless systemd has suddenly become the standard init system.

Totally agreed; it's been set back to critical.  I've been suffering
from it also.

> Even worse, systemd is behaving incorrectly in this case, as it is
> SKIPPING fsck instead of finding the root device some other way and
> running fsck on that (though this would still trigger bug #712078). So
> ultimately, the issue is either:
> * in mountpoint's syscall for getting the device node, or
> * in checkroot.sh which needs some btrfs-specific method to find the
> correct argument to pass to btrfsck/btrfs check (taking subvolumes
> into account)
> 
> I've attached an alternative patch for checkroot.sh that explicitly
> checks for btrfs and, more importantly, triggers a warning when it is
> detected.

I didn't see an attachment.  I'll be happy to look over it and apply it
--it needs to be worked around in the short term irrespective of it
being fixed down the line.  Though I hope the btrfs tools are fixed
since they are currently horribly broken.


Thanks,
Roger

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux    http://people.debian.org/~rleigh/
 `. `'   schroot and sbuild  http://alioth.debian.org/projects/buildd-tools
   `-    GPG Public Key      F33D 281D 470A B443 6756 147C 07B3 C8BC 4083 E800



Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#701956; Package initscripts. (Sat, 13 Jul 2013 16:39:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ben Klein <shacklein@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. (Sat, 13 Jul 2013 16:39:09 GMT) Full text and rfc822 format available.

Message #68 received at 701956@bugs.debian.org (full text, mbox):

From: Ben Klein <shacklein@gmail.com>
To: Roger Leigh <rleigh@codelibre.net>
Cc: 701956@bugs.debian.org
Subject: Re: Bug#701956: btrfs can't fsck /run/rootdev on boot
Date: Sun, 14 Jul 2013 02:36:37 +1000
[Message part 1 (text/plain, inline)]
Let's try this again. Simple, explicit test for btrfs, patch attached.

On 14 July 2013 01:53, Roger Leigh <rleigh@codelibre.net> wrote:
> On Wed, Jul 03, 2013 at 11:27:07PM +1000, Ben Klein wrote:
>> Bug still occurs with
>> * btrfs-tools 0.19+20130315-2
>> * sysv-rc 2.88dsf-41
>> * sysvinit 2.88dsf-41
>> * sysvinit-utils 2.88dsf-41
>> * initscripts 2.88dsf-41
>>
>> I notice this bug has been reduced in severity from "critical" to
>> "important" again. Sorry, but I have to agree that it IS a critical
>> bug, unless systemd has suddenly become the standard init system.
>
> Totally agreed; it's been set back to critical.  I've been suffering
> from it also.
>
>> Even worse, systemd is behaving incorrectly in this case, as it is
>> SKIPPING fsck instead of finding the root device some other way and
>> running fsck on that (though this would still trigger bug #712078). So
>> ultimately, the issue is either:
>> * in mountpoint's syscall for getting the device node, or
>> * in checkroot.sh which needs some btrfs-specific method to find the
>> correct argument to pass to btrfsck/btrfs check (taking subvolumes
>> into account)
>>
>> I've attached an alternative patch for checkroot.sh that explicitly
>> checks for btrfs and, more importantly, triggers a warning when it is
>> detected.
>
> I didn't see an attachment.  I'll be happy to look over it and apply it
> --it needs to be worked around in the short term irrespective of it
> being fixed down the line.  Though I hope the btrfs tools are fixed
> since they are currently horribly broken.
>
>
> Thanks,
> Roger
>
> --
>   .''`.  Roger Leigh
>  : :' :  Debian GNU/Linux    http://people.debian.org/~rleigh/
>  `. `'   schroot and sbuild  http://alioth.debian.org/projects/buildd-tools
>    `-    GPG Public Key      F33D 281D 470A B443 6756 147C 07B3 C8BC 4083 E800
[checkroot.sh-skip_btrfs.diff (application/octet-stream, attachment)]

Reply sent to Roger Leigh <rleigh@debian.org>:
You have taken responsibility. (Sun, 14 Jul 2013 09:36:23 GMT) Full text and rfc822 format available.

Notification sent to Axel Beckert <abe@debian.org>:
Bug acknowledged by developer. (Sun, 14 Jul 2013 09:36:23 GMT) Full text and rfc822 format available.

Message #73 received at 701956-close@bugs.debian.org (full text, mbox):

From: Roger Leigh <rleigh@debian.org>
To: 701956-close@bugs.debian.org
Subject: Bug#701956: fixed in sysvinit 2.88dsf-42
Date: Sun, 14 Jul 2013 09:33:40 +0000
Source: sysvinit
Source-Version: 2.88dsf-42

We believe that the bug you reported is fixed in the latest version of
sysvinit, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 701956@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Roger Leigh <rleigh@debian.org> (supplier of updated sysvinit package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@ftp-master.debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA512

Format: 1.8
Date: Sat, 13 Jul 2013 21:24:31 +0100
Source: sysvinit
Binary: sysvinit sysvinit-utils sysv-rc initscripts bootlogd
Architecture: source amd64 all
Version: 2.88dsf-42
Distribution: unstable
Urgency: low
Maintainer: Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>
Changed-By: Roger Leigh <rleigh@debian.org>
Description: 
 bootlogd   - daemon to log boot messages
 initscripts - scripts for initializing and shutting down the system
 sysv-rc    - System-V-like runlevel change mechanism
 sysvinit   - System-V-like init utilities
 sysvinit-utils - System-V-like utilities
Closes: 423528 606505 677369 685779 694252 701956 710304
Changes: 
 sysvinit (2.88dsf-42) unstable; urgency=low
 .
   [ Roger Leigh ]
   * Introduce jessie changes from 2.88dsf-41+jessie1 to unstable.
   * Correct the Breaks on bootchart to ensure that all broken
     versions are removed on upgrade (Closes: #694252).  Break
     bootchart << 0.10~svn407-4 to ensure that 0.10~svn407-3.3
     and earlier are removed.
   * Clean up legacy migration logic in maintainer scripts and init
     scripts for /run, /lib/init/rw, /etc/mtab, /etc/motd.
   * Don't generate debian/copyright; include missing bits of
     COPYRIGHT directly.
   * Upgrade to Standards-Version 3.9.4 (no changes).
   * Add lintian overrides for init script dependency warnings;
     these don't apply to our scripts since they have special
     dependency requirements.
   * bootlogd: Ensure boot logs are flushed (Closes: #423528).  Save
     logs in /run/bootlog and copy to /var/log/boot at the end of the
     boot sequence.
   * sysv-rc:
     - update-rc.d no longer supports non-dependency-based boot.
       + Remove non-insserv codepaths.
       + Warn if the start or stop actions are used.
       + Skip runlevel mismatch warnings if default action is used
         (no arguments to validate).
       + Update manual page to remove start and stop actions, plus
         manual setting of boot sequence ordering; note that start
         and stop are no longer supported.  Closes: #606505.
   * initscripts:
     - Remove static runlevels from update-rc.d calls in postinst.
     - checkroot.sh skips fsck of btrfs filesystems.  Thanks to Ben
       Klein for this patch.  Closes: #701956.  Note that this is
       intended to be a workaround until such time btrfs provides a
       non-broken fsck.btrfs.
     - Remove use of absolute program paths in postinst.
   * bootlogd:
     - Remove static runlevels from update-rc.d calls in postinst.
 .
   [ Pino Toscano ]
   * Update inittab.gnu to the new path of Hurd's getty.
   * mount-functions.sh: do not add "nodev" to the mount options also on Hurd,
     as this option does not exist there.
 .
   [ Steve Langasek ]
   * Kill pointless script-not-executable overrides for things that are not
     scripts.
   * /etc/default/rcS is a conffile; remove postinst code that attempts to
     create it from a non-existent template.
   * Relax the Breaks: on upstart for compatibility with Ubuntu.
   * Don't duplicate the /etc/default/rcS conffile with a template in the
     preinst; unmodified files should just be removed, and created
     automatically by dpkg.
   * Fix 'service $foo restart' implementation for upstart jobs.
   * Update service(8) manpage to document the support for upstart jobs.
   * debian/sysv-rc/sbin/invoke-rc.d: replace RUNLEVEL with RUNLEVELHELPER.
     Using RUNLEVEL causes spurious failures when invoke-rc.d is invoked
     with RUNLEVEL already defined in the environment (as it is e.g. during
     bootup) since invoke-rc.d's RUNLEVEL will become an exported variable
     at that point and cause /sbin/runlevel to return bad data. (LP: #619246)
     Thanks to James Troup for the patch.
   * Properly clean up bootlogd conffiles on upgrade using dpkg-maintscript,
     instead of leaving them orphaned on the filesystem when the bootlogd
     package is not installed.
   * Drop maintainer script migration code for versions older than squeeze.
   * Mark sysv-rc Multi-Arch: foreign, now that debhelper is generating
     versioned dependencies on it, this is important for cross-installability
     of packages providing services.  Closes: #710304.
   * Also mark initscripts Multi-Arch: foreign, for similar reasons.  This is
     probably less important, given that the number of packages affected is
     small and the /run transition is already past, but it is still correct
     in its own right so might as well be added.  Closes: #677369.
 .
   [ Michael Biebl ]
   * Redirect error output from 'initctl version', suppressing warnings when
     upstart is installed but not running.  Closes: #685779.
Checksums-Sha1: 
 15e3437ad9bf7dd03b6dce1d45a22ab61b7af5ee 2342 sysvinit_2.88dsf-42.dsc
 7bc01207c58f9c6dda74aaa4e6560b54d00c4c7e 204956 sysvinit_2.88dsf-42.debian.tar.gz
 220388398d68f6280d9c2966bf89d6e5d75fc995 134140 sysvinit_2.88dsf-42_amd64.deb
 12a4a2dfe8553141581acd6580314b7aeb429482 103196 sysvinit-utils_2.88dsf-42_amd64.deb
 98418e450eb739877443a4162d9ea856f1266860 80372 sysv-rc_2.88dsf-42_all.deb
 a2fea71f1833d0710415f7a76c55e0eccc9bbdaa 87124 initscripts_2.88dsf-42_amd64.deb
 0abfaee7980b13f19ab73019c5e3f4ed63e1845d 56936 bootlogd_2.88dsf-42_amd64.deb
Checksums-Sha256: 
 5d19c33880ebf6ea9220a8b6b6df09c7940e044a8bab8b94f8dfbfe392b0525e 2342 sysvinit_2.88dsf-42.dsc
 104867b5754018e0127ab9341cd623be92c4dbd8370b9b5e53716ec04d4dffa3 204956 sysvinit_2.88dsf-42.debian.tar.gz
 8f28a20489d1f4bf760eba11a8e24d152dc2087589cb7b6fee58a84375f1e898 134140 sysvinit_2.88dsf-42_amd64.deb
 1c021845ec18d49c3d551117c270b7a0d0b411c46d97a15b612070b47e3d5294 103196 sysvinit-utils_2.88dsf-42_amd64.deb
 872324dc72bca92ef02d3138d0fab2934a0ab2ed2134df1476be21a028447d78 80372 sysv-rc_2.88dsf-42_all.deb
 a4da0e84ce61dfc133174b87c9c8533708ed351d767c37e6ab06e38d981b1034 87124 initscripts_2.88dsf-42_amd64.deb
 ca3f32ae02b070bb03771d4fb65ba232fdb0c2e56f11cc24c1c1a38988bfaa0c 56936 bootlogd_2.88dsf-42_amd64.deb
Files: 
 f1328e77b57e12891bd9116422133f12 2342 admin required sysvinit_2.88dsf-42.dsc
 f6b6c07bdc43f33dfa21d42c228f1ebd 204956 admin required sysvinit_2.88dsf-42.debian.tar.gz
 0d2749fc9f6ca14518a99eec3de88896 134140 admin required sysvinit_2.88dsf-42_amd64.deb
 b36fb14620bc2bd5a540af7969b0a580 103196 admin required sysvinit-utils_2.88dsf-42_amd64.deb
 18d318fa70e2026ea16280f1bbcaf2ce 80372 admin required sysv-rc_2.88dsf-42_all.deb
 dcba456a02cffe3eca293455fe6d46c4 87124 admin required initscripts_2.88dsf-42_amd64.deb
 027f848093ef8c86987ec0e810c52c2b 56936 admin optional bootlogd_2.88dsf-42_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIcBAEBCgAGBQJR4eqaAAoJEOJSSsUKn1xZU0gP/3hJImMGn+ugV49pxHuput4W
pqDo2L79Ku94nGUMeEAPw8ikMGx7ANKMoFp0+tmJAd7WRuU3wL2vmcPmhtaJA/bl
OPTJ4eCsNLtLfC5LvwXKrQ0/PwPky2qn3uQhCwr48pedfZ4GM36Dmz2m3L5yU+0M
WhS/z2zIUTVX1IgtxHJPlpQ6Z9mHganJVG+nt/LocxRP+VQQQxhY6Jt9DnBJo0lP
qIpakkNzWS7Yyrlo4gu57Pvo1jirb4+UWwJ998SiQDdQON94DkFD7FPp3lPQMDUr
2GKpzEBr2Jkw32OgyMsrARlsRanuNIK0MeOG8/nomZf8L982turn1GUaEAdrrmWM
zX1e68bf3f7Tt+PdMdYqhY5CO2Hqojfc2FmQqrcaNz+IuEocSD/vsil0baiYxI4o
iM9z/NCyEymH5tOUHs32+ooLfkCs0y/kKHNnUFDJjvJfckIOal8F1GcyD2mv2mIg
sN7JqaBB+Fxm+iCddUiAh9IIrkrNhcGWOFmFoc6fVDpt3oilp4NhcksX+L7nG/o6
6vp7lcEtdiwA8uiy1WCULyhaTDjhWDpS815U8QE0VOI7+E94c8W0MYWKxyEkAYg5
OF2xdXQi3hlNsyKEmly54Met0Md+lp2cTSkZV4fNhczkoBP9/WEvHrSs5GlmDsgx
l6+F0l9SNME7f3kOqfj7
=Meas
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 06 Feb 2014 07:30:30 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 18 08:43:46 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.